diff -ruN qmail-1.03-orig/QLDAPPICTURE qmail-1.03-ldap-20060201-orig/QLDAPPICTURE
--- qmail-1.03-orig/QLDAPPICTURE	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/QLDAPPICTURE	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,29 @@
+ 1. qmail-smtpd accepts connection
+
+    Is relayclient set?
+      Yes -> accept it anyway.
+      No  -> check if recipient domain is listed in rcpthosts else
+             deny
+
+    Does sender's domain have a valid MX or A record?
+      Yes -> accept for data
+      No  -> deny
+
+    Now the message gets queued.
+
+ 2. qmail-send takes a look at it
+
+    Is the recipients domain in virtualhosts or locals (doesn't matter
+    with qmail-ldap)?
+      Yes -> feed it to qmail-lspawn for local delivery
+      No  -> feed it to qmail-rspawn for remote delivery (relaying as
+             usual)
+
+ 3. qmail-lspawn gets it for local delivery
+
+    Is the recipients full email address found in the LDAP directory?
+      Yes -> check if all needed attributes are present
+               Yes -> deliver it to the maildir
+               No  -> bounce
+      No  -> try a standard qmail (UNIX user or ~users/assign) delivery
+
diff -ruN qmail-1.03-orig/qldap-profile.c qmail-1.03-ldap-20060201-orig/qldap-profile.c
--- qmail-1.03-orig/qldap-profile.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/qldap-profile.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,77 @@
+/*
+ * Copyright (c) 2000-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#include "taia.h"
+#include "qldap-profile.h"
+#include "qldap-debug.h"
+
+struct profile_t {
+	struct taia start;
+	char *function;
+};
+	
+static struct profile_t profile_list[PROFILES_MAX];
+
+void start_timing(unsigned int profile, char *function)
+{
+	if (profile >= PROFILES_MAX) {
+		debug(0x400, "Max Number of profiles exceeded\n");
+		return;
+	}
+	
+	taia_now(&(profile_list[profile].start));
+
+}
+
+void stop_timing(unsigned int profile) 
+{
+	struct taia stop;
+	struct taia diff;
+	char nano[TAIA_FMTFRAC];
+	unsigned long sec;
+	
+	if (profile >= PROFILES_MAX) {
+		debug(0x400, "Max Number of profiles exceeded\n");
+		return;
+	}
+
+	taia_now(&stop);
+
+	taia_sub(&diff, &stop, &profile_list[profile].start);
+	nano[taia_fmtfrac(nano, &diff)] = 0; /* terminate to be sure */
+	nano[7] = 0; /* only the first 6-7 figures are != 0, (nano seconds) */
+	sec=(unsigned long) ((unsigned long long) diff.sec.x);
+	debug(0x400, "%s took %u.%s Sec\n", profile_list[profile].function, sec, nano);
+
+}
+
diff -ruN qmail-1.03-orig/qldap-profile.h qmail-1.03-ldap-20060201-orig/qldap-profile.h
--- qmail-1.03-orig/qldap-profile.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/qldap-profile.h	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,45 @@
+/*
+ * Copyright (c) 2000-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#ifndef __QLDAP_PROFILE_H__
+#define __QLDAP_PROFILE_H__
+
+#define PROFILES_MAX 4 /* 4 concurrent profiles */
+
+void start_timing(int profile, char *function);
+/* start the timing of a function */
+
+void stop_timing(int profile);
+/* stop the timing of a function and print the difference */
+
+#endif
diff -ruN qmail-1.03-orig/QLDAPTODO qmail-1.03-ldap-20060201-orig/QLDAPTODO
--- qmail-1.03-orig/QLDAPTODO	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/QLDAPTODO	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,45 @@
+QMAIL-LDAP by Andre Oppermann <opi@nrg4u.com>,
+Claudio Jeker <jeker@n-r-g.com> and Boris Lutz <lutz@n-r-g.com>
+(c) 2000-2004 Internet Business Solutions AG
+
+RELEASE: $Date: 2004/08/03 20:27:44 $ ($Revision: 1.36 $)
+
+This is the TODO FILE, so the QLDAPINSTALL file gets a bit cleaner.
+This file is NOT structured!!
+
+NEWS:
+
+ see QLDAPNEWS
+
+TODO:
+
+ongoing - Debugging and testing, testing, testing
+done    - The big qmail-ldap picture
+ongoing - full code review by a third person
+planned - make it possible to have locals and rcpthosts in ldap
+          and perhaps also the rules for the tcpserver (certs?)
+          some people refer to this as ldap-control
+
+PS: planned means we see the use of the idea but there are a lot more
+    important things that need to be done first.
+
+ALSO ON THE LIST: (priority list)
+- update qmail-ldaplookup (mainly ldap login, passwd check and group handling)
+- cleanup the debug code, unify the debug levels
+- cleanup failures (hard vs. temporary)
+- use pbstools for enhanced tarpit idea
+- make full example for qmailaccountpurge.sh
+- docu cleanup
+- address rewriting (envelope only)
+
+older stuff still on the list:
+- add more and clearer documentation.
+- benchmarking the code
+- better TLS support (better written??) (tls for pop???)
+- 64bit counters for quota handling code.
+
+status unclear:
+- force to alias if only mail and mailforwardingaddress is set (no uid). (done)
+- test what happens if only uid and mail is defiend in ldap or similar uncommon
+  cases (seems to be no problem, or?)
+
diff -ruN qmail-1.03-orig/qlx.h qmail-1.03-ldap-20060201-orig/qlx.h
--- qmail-1.03-orig/qlx.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/qlx.h	2006-02-25 11:00:55.000000000 +0100
@@ -15,4 +15,28 @@
 #define QLX_EXECPW 121
 #define QLX_EXECHARD 126
 
+/* qmail-ldap specific exit codes */
+
+/* ldap specific errors */
+#define QLX_MAXSIZE 150
+#define QLX_LDAPFAIL 152	/* generic fail of ldap functions */
+#define QLX_LDAPAUTH 153	/* LDAP_BIND_AUTH */
+#define QLX_SEARCHTIMEOUT 154	/* TIMEOUT */
+#define QLX_BINDTIMEOUT 155	/* LDAP_BIND_UNREACH */
+#define QLX_TOOMANY 156
+#define QLX_NEEDED 157
+#define QLX_ILLVAL 158
+#define QLX_DISABLED 159
+#define QLX_DELETED 160
+
+/* cluster errors */
+#define QLX_CLUSTERSOFT 162
+#define QLX_CLUSTERHARD 163
+#define QLX_CLUSTERCRASHED 164
+#define QLX_CLUSTERLOOP 165
+/* dirmaker errors */
+#define QLX_DIRMAKESOFT 167
+#define QLX_DIRMAKEHARD 168
+#define QLX_DIRMAKECRASH 169
+
 #endif
diff -ruN qmail-1.03-orig/qmailAccountPurge.sh qmail-1.03-ldap-20060201-orig/qmailAccountPurge.sh
--- qmail-1.03-orig/qmailAccountPurge.sh	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/qmailAccountPurge.sh	2006-02-25 11:00:56.000000000 +0100
@@ -0,0 +1,22 @@
+#!/bin/sh
+
+case "$1" in
+
+show)
+
+        /usr/local/bin/ldapsearch \
+        -u -F "=" \
+        -h "`cat /var/qmail/control/ldapserver`" \
+        -b "`cat /var/qmail/control/ldapbasedn`" \
+        -S "mail" \
+        "(&(accountStatus=deleted)(qmailAccountPurge=<`/var/qmail/bin/gettimeofday`))" \
+        mail mailAlternateAddress uid mailMessageStore mailHost
+
+        ;;
+
+purge)
+
+	;;
+
+esac
+
diff -ruN qmail-1.03-orig/qmail.c qmail-1.03-ldap-20060201-orig/qmail.c
--- qmail-1.03-orig/qmail.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/qmail.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,3 +1,4 @@
+#include <unistd.h>
 #include "substdio.h"
 #include "readwrite.h"
 #include "wait.h"
@@ -7,7 +8,24 @@
 #include "qmail.h"
 #include "auto_qmail.h"
 
+#ifdef ALTQUEUE
+#include "env.h"
+
+static char *binqqargs[2] = { 0, 0 } ;
+
+static void
+setup_qqargs(void)
+{
+  if(!binqqargs[0])
+    binqqargs[0] = (char *)env_get("QMAILQUEUE");
+  if(!binqqargs[0])
+    binqqargs[0] = (char *)"bin/qmail-queue";
+}
+
+#else
 static char *binqqargs[2] = { "bin/qmail-queue", 0 } ;
+#endif
+
 
 int qmail_open(qq)
 struct qmail *qq;
@@ -15,6 +33,10 @@
   int pim[2];
   int pie[2];
 
+#ifdef ALTQUEUE
+  setup_qqargs();
+#endif
+
   if (pipe(pim) == -1) return -1;
   if (pipe(pie) == -1) { close(pim[0]); close(pim[1]); return -1; }
  
@@ -35,7 +57,44 @@
 
   qq->fdm = pim[1]; close(pim[0]);
   qq->fde = pie[1]; close(pie[0]);
-  substdio_fdbuf(&qq->ss,write,qq->fdm,qq->buf,sizeof(qq->buf));
+  substdio_fdbuf(&qq->ss,subwrite,qq->fdm,qq->buf,sizeof(qq->buf));
+  qq->flagerr = 0;
+  return 0;
+}
+
+int qmail_remote(qq, host)
+struct qmail *qq;
+char *host;
+{
+  int pim[2];
+  int pie[2];
+  char *(args[3]);
+
+  args[0] = (char *)"bin/qmail-qmqpc";
+  args[1] = host;
+  args[2] = 0;
+
+  if (pipe(pim) == -1) return -1;
+  if (pipe(pie) == -1) { close(pim[0]); close(pim[1]); return -1; }
+ 
+  switch(qq->pid = vfork()) {
+    case -1:
+      close(pim[0]); close(pim[1]);
+      close(pie[0]); close(pie[1]);
+      return -1;
+    case 0:
+      close(pim[1]);
+      close(pie[1]);
+      if (fd_move(0,pim[0]) == -1) _exit(120);
+      if (fd_move(1,pie[0]) == -1) _exit(120);
+      if (chdir(auto_qmail) == -1) _exit(61);
+      execv(*args,args);
+      _exit(120);
+  }
+
+  qq->fdm = pim[1]; close(pim[0]);
+  qq->fde = pie[1]; close(pie[0]);
+  substdio_fdbuf(&qq->ss,subwrite,qq->fdm,qq->buf,sizeof(qq->buf));
   qq->flagerr = 0;
   return 0;
 }
@@ -50,34 +109,34 @@
   qq->flagerr = 1;
 }
 
-void qmail_put(qq,s,len) struct qmail *qq; char *s; int len;
+void qmail_put(qq,s,len) struct qmail *qq; const char *s; int len;
 {
   if (!qq->flagerr) if (substdio_put(&qq->ss,s,len) == -1) qq->flagerr = 1;
 }
 
-void qmail_puts(qq,s) struct qmail *qq; char *s;
+void qmail_puts(qq,s) struct qmail *qq; const char *s;
 {
   if (!qq->flagerr) if (substdio_puts(&qq->ss,s) == -1) qq->flagerr = 1;
 }
 
-void qmail_from(qq,s) struct qmail *qq; char *s;
+void qmail_from(qq,s) struct qmail *qq; const char *s;
 {
   if (substdio_flush(&qq->ss) == -1) qq->flagerr = 1;
   close(qq->fdm);
-  substdio_fdbuf(&qq->ss,write,qq->fde,qq->buf,sizeof(qq->buf));
+  substdio_fdbuf(&qq->ss,subwrite,qq->fde,qq->buf,sizeof(qq->buf));
   qmail_put(qq,"F",1);
   qmail_puts(qq,s);
   qmail_put(qq,"",1);
 }
 
-void qmail_to(qq,s) struct qmail *qq; char *s;
+void qmail_to(qq,s) struct qmail *qq; const char *s;
 {
   qmail_put(qq,"T",1);
   qmail_puts(qq,s);
   qmail_put(qq,"",1);
 }
 
-char *qmail_close(qq)
+const char *qmail_close(qq)
 struct qmail *qq;
 {
   int wstat;
@@ -87,7 +146,7 @@
   if (!qq->flagerr) if (substdio_flush(&qq->ss) == -1) qq->flagerr = 1;
   close(qq->fde);
 
-  if (wait_pid(&wstat,qq->pid) != qq->pid)
+  if ((unsigned long)wait_pid(&wstat,qq->pid) != qq->pid)
     return "Zqq waitpid surprise (#4.3.0)";
   if (wait_crashed(wstat))
     return "Zqq crashed (#4.3.0)";
diff -ruN qmail-1.03-orig/qmail-cdb.c qmail-1.03-ldap-20060201-orig/qmail-cdb.c
--- qmail-1.03-orig/qmail-cdb.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/qmail-cdb.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,111 @@
+/*
+ * Copyright (c) 2003-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+
+/*
+ * Based on similar code by D. J. Bernstein
+ */
+
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <stdio.h>
+#include <unistd.h>
+#include "auto_qmail.h"
+#include "case.h"
+#include "cdb_make.h"
+#include "exit.h"
+#include "getln.h"
+#include "open.h"
+#include "readwrite.h"
+#include "stralloc.h"
+#include "strerr.h"
+#include "substdio.h"
+
+#define FATAL "qmail-cdb: fatal: "
+
+void die_read(void)
+{
+  strerr_die2sys(111,FATAL,"unable to read from stdin: ");
+}
+void die_write(const char *f)
+{
+  strerr_die4sys(111,FATAL,"unable to write to ", f, ": ");
+}
+
+char inbuf[1024];
+substdio ssin;
+
+int fd;
+int fdtemp;
+
+struct cdb_make cdbm;
+stralloc line = {0};
+int match;
+
+int main(int argc, char **argv)
+{
+  umask(033);
+
+  if (argc != 3)
+    strerr_die1sys(111,"qmail-cdb: usage: qmail-cdb rules.cdb rules.tmp");
+
+  substdio_fdbuf(&ssin,subread,0,inbuf,sizeof inbuf);
+
+  fdtemp = open_trunc(argv[2]);
+  if (fdtemp == -1) die_write(argv[2]);
+
+  if (cdb_make_start(&cdbm,fdtemp) == -1) die_write(argv[2]);
+
+  for (;;) {
+    if (getln(&ssin,&line,&match,'\n') != 0) die_read();
+    case_lowerb(line.s,line.len);
+    while (line.len) {
+      if (line.s[line.len - 1] == ' ') { --line.len; continue; }
+      if (line.s[line.len - 1] == '\n') { --line.len; continue; }
+      if (line.s[line.len - 1] == '\t') { --line.len; continue; }
+      if (line.s[0] != '#')
+	if (cdb_make_add(&cdbm,line.s,line.len,"",0) == -1)
+	  die_write(argv[2]);
+      break;
+    }
+    if (!match) break;
+  }
+
+  if (cdb_make_finish(&cdbm) == -1) die_write(argv[2]);
+  if (fsync(fdtemp) == -1) die_write(argv[2]);
+  if (close(fdtemp) == -1) die_write(argv[2]); /* NFS stupidity */
+  if (rename(argv[2],argv[1]) == -1)
+    strerr_die5sys(111, FATAL, "unable to move ", argv[2], " to ", argv[1]);
+
+  return 0;
+}
diff -ruN qmail-1.03-orig/qmail-clean.c qmail-1.03-ldap-20060201-orig/qmail-clean.c
--- qmail-1.03-orig/qmail-clean.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/qmail-clean.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,5 +1,6 @@
 #include <sys/types.h>
 #include <sys/stat.h>
+#include <unistd.h>
 #include "readwrite.h"
 #include "sig.h"
 #include "now.h"
@@ -26,12 +27,12 @@
  DIR *dir;
  direntry *d;
  struct stat st;
- datetime_sec time;
+ datetime_sec tnow;
 
- time = now();
+ tnow = now();
  dir = opendir("pid");
  if (!dir) return;
- while (d = readdir(dir))
+ while ((d = readdir(dir)))
   {
    if (str_equal(d->d_name,".")) continue;
    if (str_equal(d->d_name,"..")) continue;
@@ -39,7 +40,7 @@
    if (!stralloc_cats(&line,d->d_name)) continue;
    if (!stralloc_0(&line)) continue;
    if (stat(line.s,&st) == -1) continue;
-   if (time < st.st_atime + OSSIFIED) continue;
+   if (tnow < st.st_atime + OSSIFIED) continue;
    unlink(line.s);
   }
  closedir(dir);
@@ -49,9 +50,9 @@
 
 void respond(s) char *s; { if (substdio_putflush(subfdoutsmall,s,1) == -1) _exit(100); }
 
-void main()
+int main()
 {
- int i;
+ unsigned int i;
  int match;
  int cleanuploop;
  unsigned long id;
@@ -73,26 +74,47 @@
    if (line.len < 7) { respond("x"); continue; }
    if (line.len > 100) { respond("x"); continue; }
    if (line.s[line.len - 1]) { respond("x"); continue; } /* impossible */
+#ifndef BIGTODO
    for (i = 5;i < line.len - 1;++i)
+#else
+   for (i = line.len - 2;i > 4;--i)
+    {
+      if (line.s[i] == '/') break;
+#endif
      if ((unsigned char) (line.s[i] - '0') > 9)
       { respond("x"); continue; }
+#ifndef BIGTODO
    if (!scan_ulong(line.s + 5,&id)) { respond("x"); continue; }
+#else
+    }
+   if (line.s[i] == '/')
+     if (!scan_ulong(line.s + i + 1,&id)) { respond("x"); continue; }
+#endif
    if (byte_equal(line.s,5,"foop/"))
     {
 #define U(prefix,flag) fmtqfn(fnbuf,prefix,id,flag); \
 if (unlink(fnbuf) == -1) if (errno != error_noent) { respond("!"); continue; }
+#ifndef BIGTODO
      U("intd/",0)
+#else
+     U("intd/",1)
+#endif
      U("mess/",1)
      respond("+");
     }
-   else if (byte_equal(line.s,4,"todo/"))
+   else if (byte_equal(line.s,5,"todo/"))
     {
+#ifndef BIGTODO
      U("intd/",0)
      U("todo/",0)
+#else
+     U("intd/",1)
+     U("todo/",1)
+#endif
      respond("+");
     }
    else
      respond("x");
   }
- _exit(0);
+ return 0;
 }
diff -ruN qmail-1.03-orig/qmail-forward.c qmail-1.03-ldap-20060201-orig/qmail-forward.c
--- qmail-1.03-orig/qmail-forward.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/qmail-forward.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,179 @@
+/*
+ * Copyright (c) 2003-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#include <unistd.h>
+#include "auto_qmail.h"
+#include "control.h"
+#include "error.h"
+#include "fmt.h"
+#include "getln.h"
+#include "now.h"
+#include "qmail.h"
+#include "readwrite.h"
+#include "seek.h"
+#include "str.h"
+#include "stralloc.h"
+#include "strerr.h"
+#include "substdio.h"
+
+
+#define FATAL "qmail-forward: fatal: "
+
+void
+usage(void)
+{
+	strerr_die1x(100,
+	    "qmail-forward: usage: qmail-forward host sender recipient");
+}
+
+void
+temp_nomem(void)
+{
+	strerr_die2x(111, FATAL, "Out of memory. (#4.3.0)");
+}
+void
+temp_rewind(void)
+{
+	strerr_die2x(111, FATAL, "Unable to rewind message. (#4.3.0)");
+}
+void
+temp_read(void)
+{
+	strerr_die3x(111, "Unable to read message: ",
+	    error_str(errno), ". (#4.3.0)");
+}
+void
+temp_fork(void)
+{
+	strerr_die3x(111, "Unable to fork: ", error_str(errno), ". (#4.3.0)");
+}
+
+
+
+char buf[4096];
+
+stralloc me = {0};
+stralloc dtline = {0};
+stralloc messline = {0};
+
+void bouncexf(void)
+{
+	substdio ss;
+	int match;
+
+	if (seek_begin(0) == -1) temp_rewind();
+	substdio_fdbuf(&ss, subread, 0, buf, sizeof(buf));
+	for (;;)
+	{
+		if (getln(&ss, &messline, &match, '\n') != 0) temp_read();
+		if (!match) break;
+		if (messline.len <= 1)
+			break;
+		if (messline.len == dtline.len)
+			if (!str_diffn(messline.s, dtline.s, dtline.len))
+				strerr_die2x(100, FATAL, 
+				    "This message is looping: "
+				    "it already has my Cluster-Delivered-To "
+				    "line. (#5.4.6)\n");
+	}
+}
+
+char strnum1[FMT_ULONG];
+char strnum2[FMT_ULONG];
+
+int
+main (int argc, char **argv)
+{
+	struct qmail qqt;
+	substdio ss;
+	char *remote, *to, *from;
+	const char *qqx;
+	unsigned long qp;
+	datetime_sec when;
+	int match;
+	unsigned int i;
+	
+	if (!(remote = argv[1])) usage();
+	if (!(from = argv[2])) usage();
+	if (!(to = argv[3])) usage();
+	if (argv[4]) usage();
+	
+	if (chdir(auto_qmail) == -1)
+		strerr_die4sys(111, FATAL, "Unable to switch to ",
+		    auto_qmail, ": ");
+	if (control_init() == -1)
+		strerr_die2sys(111, FATAL, "Unable to read controls: ");
+	if (control_readline(&me, "control/me") != 1)
+		strerr_die2sys(111, FATAL, "Unable to read control/me: ");
+
+	
+	if (!stralloc_copys(&dtline, "Delivered-To: CLUSTERHOST "))
+		temp_nomem();
+	if (!stralloc_cat(&dtline, &me)) temp_nomem();
+	if (!stralloc_cats(&dtline, " ")) temp_nomem();
+	if (!stralloc_cats(&dtline, to)) temp_nomem();
+	for (i = 0; i < dtline.len; ++i)
+		if (dtline.s[i] == '\n')
+			dtline.s[i] = '_';
+	if (!stralloc_cats(&dtline, "\n")) temp_nomem();
+
+	bouncexf();
+	
+	if (seek_begin(0) == -1) temp_rewind();
+	substdio_fdbuf(&ss, subread, 0, buf, sizeof(buf));
+
+	if (qmail_remote(&qqt, remote) == -1) temp_fork();
+	qp = qmail_qp(&qqt);
+
+	qmail_put(&qqt, dtline.s, dtline.len);
+	do {
+		if (getln(&ss, &messline, &match, '\n') != 0) {
+			qmail_fail(&qqt);
+			break;
+		}
+		qmail_put(&qqt, messline.s, messline.len);
+	} while (match);
+	qmail_from(&qqt, from);
+	qmail_to(&qqt, to);
+	qqx = qmail_close(&qqt);
+	if (*qqx) 
+		strerr_die3x(*qqx == 'D' ? 100 : 111,
+		    "Unable to cluster-forward message: ", qqx + 1, ".");
+	when = now();
+	strnum1[fmt_ulong(strnum1, (unsigned long) when)] = 0;
+	strnum2[fmt_ulong(strnum2, qp)] = 0;
+	strerr_die5x(0, "qmail-forward: ok ", strnum1, " qp ", strnum2, ".");
+	/* NOTREACHED */
+	return 0;
+}
+
diff -ruN qmail-1.03-orig/qmail-getpw.c qmail-1.03-ldap-20060201-orig/qmail-getpw.c
--- qmail-1.03-orig/qmail-getpw.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/qmail-getpw.c	2006-02-25 11:00:55.000000000 +0100
@@ -18,7 +18,7 @@
 
 char *local;
 struct passwd *pw;
-char *dash;
+const char *dash;
 char *extension;
 
 int userext()
@@ -28,7 +28,7 @@
 
   extension = local + str_len(local);
   for (;;) {
-    if (extension - local < sizeof(username))
+    if ((unsigned long)(extension - local) < sizeof(username))
       if (!*extension || (*extension == *auto_break)) {
 	byte_copy(username,extension - local,local);
 	username[extension - local] = 0;
@@ -37,7 +37,7 @@
 	pw = getpwnam(username);
 	if (errno == error_txtbsy) _exit(QLX_SYS);
 	if (pw)
-	  if (pw->pw_uid)
+	  if (pw->pw_uid) {
 	    if (stat(pw->pw_dir,&st) == 0) {
 	      if (st.st_uid == pw->pw_uid) {
 		dash = "";
@@ -47,6 +47,7 @@
 	    }
 	    else
 	      if (error_temp(errno)) _exit(QLX_NFS);
+	  }
       }
     if (extension == local) return 0;
     --extension;
@@ -55,7 +56,7 @@
 
 char num[FMT_ULONG];
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
@@ -84,5 +85,5 @@
   substdio_put(subfdoutsmall,"",1);
   substdio_flush(subfdoutsmall);
 
-  _exit(0);
+  return 0;
 }
